
// +----------------------------------------------------------------------------------------+ //
// |    .-._______                           XARD777                          _______.-.    | //
// |---( )_)______)                 Knowledge of the ancients                (______(_( )---| //
// |  (    ()___)                              \/                             (___()    )  | //
// |       ()__)                              (o o)                             (__()       | //
// |--(___()_)__________________________oOOo___(_)___oOOo_________________________(_()___)--| //
// |_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|____|_____| //
// |                                                                                   2011 | //
// |----------------------------------------------------------------------------------------| //
// |                 File:     !BDP AUTO FIBO v3.mq4                                        | //
// | Programming language:     MQL4                                                         | //
// | Development platform:     MetaTrader 4                                                 | //
// |          End product:     Indicator for MetaTrader 4 designed                          | //
// |                           for Build 229 (current version)                              | //
// |                                                               [BILLION DOLLAR PROJECT] | //
// +----------------------------------------------------------------------------------------+ //

#property indicator_chart_window

// ------------------------------------------------------------------------------------------ //
//                            E X T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //
 
   extern int     PeriodsBack          = 20; 
   extern int     GMT                  = 2;
   extern int     Fibo.Line.Width      = 3;

// ------------------------------------------------------------------------------------------ //
//                            I N T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //
               
   double         range[],
                  timeshift[],
                  low[],
                  high[],
                  myPoint,
                  AUTOSELECT;
                  
   datetime       time1,
                  time2,
                  start_time[],
                  prevDay              = 0;

   int            shift,
                  num,
                  CountDays,
                  ny_shift[],
                  FiboLineStyle        = 0;
   
   bool           fTime;     

// ------------------------------------------------------------------------------------------ //
//                             I N I T I A L I S A T I O N                                    //
// ------------------------------------------------------------------------------------------ //

   int init()
   {
   CountDays = PeriodsBack;
   fTime = true;
   IndicatorBuffers(2);
   SetIndexBuffer(0,range);
   SetIndexBuffer(1,timeshift);

// ------------------------------------------------------------------------------------------ //   
   switch ( Period() )
   {
   case     5: AUTOSELECT = PERIOD_D1;break;
   case    15: AUTOSELECT = PERIOD_D1;break;
   case    30: AUTOSELECT = PERIOD_D1;break;
   case    60: AUTOSELECT = PERIOD_D1;break;
   case   240: AUTOSELECT = PERIOD_W1;break;
   case  1440: AUTOSELECT = PERIOD_MN1;break;
   default   : AUTOSELECT = PERIOD_D1;break;
   }
// ------------------------------------------------------------------------------------------ //    
   return(0);
   }
  
// ------------------------------------------------------------------------------------------ //
//                            D E - I N I T I A L I S A T I O N                               //
// ------------------------------------------------------------------------------------------ //  
  
   int deinit()
   {
   deleteObjects();
   ObjectsDeleteAll(0,OBJ_TREND);
   return(0);
   }

// ------------------------------------------------------------------------------------------ //
//                                M A I N   P R O C E D U R E                                 //
// ------------------------------------------------------------------------------------------ //

   int start()
   {

   double P;
      
   if(Period()>1440) return(0);
  
   datetime cDay = iTime(NULL,AUTOSELECT,0) + (GMT-Period()/60.0)*3600;
   if (cDay != prevDay || fTime)  
   {
 
   ArrayResize(start_time,CountDays+1);
   ArrayResize(ny_shift,CountDays+1);
   ArrayResize(high,CountDays+1);
   ArrayResize(low,CountDays+1); 
   ArrayResize(range,CountDays+1);    
   
   for (shift=0;shift<=CountDays;shift++)
   {
   start_time[shift]  = iTime(NULL,AUTOSELECT,shift) + (GMT-Period()/60.0)*3600;
   ny_shift[shift] = iBarShift(NULL,0,start_time[shift]);
   timeshift[shift] = iClose(NULL,0,ny_shift[shift]);        
   }
     
   for (shift=0;shift<=CountDays-1;shift++)
   {
   int length = ny_shift[shift+1]-ny_shift[shift];
   high[shift] = High[iHighest(NULL,0,MODE_HIGH,length,ny_shift[shift])];
   low[shift]  = Low[iLowest(NULL,0,MODE_LOW,length,ny_shift[shift])];
   range[shift] = high[shift] - low[shift]; 
   }
  
   for (shift=0;shift<=CountDays-1;shift++)
   {
  
   if(DayOfWeek()==0){ P  = (timeshift[shift+1]+high[shift+1]+low[shift+1])/3; }
   else {              P  = (timeshift[shift]+high[shift]+low[shift])/3; }
      
   time1 = start_time[shift]+Period()*60;    
         
   if (shift==0) 
   {
   time2 = start_time[shift] + (AUTOSELECT*60)+Period()*60 ;
         
// ------------------------------------------------------------------------------------------ //
         
   string space="                                ";
   string p1=" : "+DoubleToStr(P,Digits);
   string p2=" : "+DoubleToStr((P*2)+(high[shift]-(low[shift]*2)),Digits);
   string p3=" : "+DoubleToStr(P+range[shift],Digits);
   string p4=" : "+DoubleToStr(P*2-low[shift],Digits);
   string p5=" : "+DoubleToStr(P*2-high[shift],Digits);
   string p6=" : "+DoubleToStr(P-range[shift],Digits);
   string p7=" : "+DoubleToStr((P*2)-((high[shift]*2)-(low[shift])),Digits);
               
   }
   else
   time2 = start_time[shift-1]+Period()*60;
   
   PlotLine("Fibo001"  +shift+"]",  low[shift] - range[shift]*0.618,  low[shift] - range[shift]*0.618,        Red, FiboLineStyle);
   PlotLine("Fibo002"  +shift+"]",  low[shift] - range[shift]*0.270,  low[shift] - range[shift]*0.270,       Lime, FiboLineStyle);
   PlotLine("Fibo003"  +shift+"]",  low[shift] + range[shift]*0.382,  low[shift] + range[shift]*0.382,       Gold, FiboLineStyle);
   PlotLine("Fibo004"       +shift+"]",  low[shift] + range[shift]*0.0,    low[shift] + range[shift]*0.0,    RoyalBlue, FiboLineStyle);
   PlotLine("Fibo005"    +shift+"]",  low[shift] + range[shift]*1.0,    low[shift] + range[shift]*1.0,    RoyalBlue, FiboLineStyle);
   PlotLine("Fibo006" +shift+"]", high[shift] - range[shift]*0.382, high[shift] - range[shift]*0.382,       Gold, FiboLineStyle);
   PlotLine("Fibo007" +shift+"]", high[shift] + range[shift]*0.270, high[shift] + range[shift]*0.270,       Lime, FiboLineStyle);
   PlotLine("Fibo008" +shift+"]", high[shift] + range[shift]*0.618, high[shift] + range[shift]*0.618,        Red, FiboLineStyle);
   }
   
   fTime = false;
   prevDay = cDay;
   }      
        
   return(0);
   }
// ------------------------------------------------------------------------------------------ //   
   void PlotLine(string name,double value,double value1,double line_color,double style)
   {
   double valueN=NormalizeDouble(value,Digits);
   double valueN1=NormalizeDouble(value1,Digits);
   bool res = ObjectCreate(name,OBJ_TREND,0,time1,valueN,time2,valueN1);
   ObjectSet(name, OBJPROP_WIDTH, Fibo.Line.Width);
   ObjectSet(name, OBJPROP_RAY, false);
   ObjectSet(name, OBJPROP_BACK, true);
   ObjectSet(name, OBJPROP_COLOR, line_color);
   }   
// ------------------------------------------------------------------------------------------ //    
   void deleteObjects(){
   
   ObjectDelete("Fibo001"); 
   ObjectDelete("Fibo002");
   ObjectDelete("Fibo003"); 
   ObjectDelete("Fibo004");
   ObjectDelete("Fibo005"); 
   ObjectDelete("Fibo006");
   ObjectDelete("Fibo007"); 
   ObjectDelete("Fibo008");
   }
// ------------------------------------------------------------------------------------------ //
//                                     E N D   P R O G R A M                                  //
// ------------------------------------------------------------------------------------------ //
/*                                                         
                                        ud$$$**BILLION$bc.                          
                                    u@**"        PROJECT$$Nu                       
                                  J                ""#$$$$$$r                     
                                 @                       $$$$b                    
                               .F                        ^*3$$$                   
                              :% 4                         J$$$N                  
                              $  :F                       :$$$$$                  
                             4F  9                       J$$$$$$$                 
                             4$   k             4$$$$bed$$$$$$$$$                 
                             $$r  'F            $$$$$$$$$$$$$$$$$r                
                             $$$   b.           $$$$$$$$$$$$$$$$$N                
                             $$$$$k 3eeed$$b    XARD777."$$$$$$$$$                
              .@$**N.        $$$$$" $$$$$$F'L $$$$$$$$$$$  $$$$$$$                
              :$$L  'L       $$$$$ 4$$$$$$  * $$$$$$$$$$F  $$$$$$F         edNc   
             @$$$$N  ^k      $$$$$  3$$$$*%   $F4$$$$$$$   $$$$$"        d"  z$N  
             $$$$$$   ^k     '$$$"   #$$$F   .$  $$$$$c.u@$$$          J"  @$$$$r 
             $$$$$$$b   *u    ^$L            $$  $$$$$$$$$$$$u@       $$  d$$$$$$ 
              ^$$$$$$.    "NL   "N. z@*     $$$  $$$$$$$$$$$$$P      $P  d$$$$$$$ 
                 ^"*$$$$b   '*L   9$E      4$$$  d$$$$$$$$$$$"     d*   J$$$$$r   
                      ^$$$$u  '$.  $$$L     "#" d$$$$$$".@$$    .@$"  z$$$$*"     
                        ^$$$$. ^$N.3$$$       4u$$$$$$$ 4$$$  u$*" z$$$"          
                          '*$$$$$$$$ *$b      J$$$$$$$b u$$P $"  d$$P             
                             #$$$$$$ 4$ 3*$"$*$ $"$'c@@$$$$ .u@$$$P               
                               "$$$$  ""F~$ $uNr$$$^&J$$$$F $$$$#                 
                                 "$$    "$$$bd$.$W$$$$$$$$F $$"                   
                                   ?k         ?$$$$$$$$$$$F'*                     
                                    9$$bL     z$$$$$$$$$$$F                       
                                     $$$$    $$$$$$$$$$$$$                        
                                      '#$$c  '$$$$$$$$$"                          
                                       .@"#$$$$$$$$$$$$b                          
                                     z*      $$$$$$$$$$$$N.                       
                                   e"      z$$"  #$$$k  '*$$.                     
                                .u*      u@$P"      '#$$c   "$$c                   
                        u@$*"""       d$$"            "$$$u  ^*$$b.               
                      :$F           J$P"                ^$$$c   '"$$$$$$bL        
                     d$$  ..      @$#                      #$$b         '#$       
                     9$$$$$$b   4$$                          ^$$k         '$      
                      "$$6""$b u$$                             '$    d$$$$$P      
                        '$F $$$$$"                              ^b  ^$$$$b$       
                         '$W$$$$"                                'b@$$$$"         
                                                                  ^$$$*/       